=== modified file 'lib/lp/code/model/branch.py'
--- lib/lp/code/model/branch.py	2011-08-22 17:40:02 +0000
+++ lib/lp/code/model/branch.py	2011-08-24 16:21:07 +0000
@@ -362,10 +362,10 @@
     @property
     def landing_candidates(self):
         """See `IBranch`."""
-        non_final = tuple(
-            set(BranchMergeProposalStatus.items) -
-            set(BRANCH_MERGE_PROPOSAL_FINAL_STATES))
-        return self.getMergeProposals(status=non_final)
+        return BranchMergeProposal.select("""
+            BranchMergeProposal.target_branch = %s AND
+            BranchMergeProposal.queue_status NOT IN %s
+            """ % sqlvalues(self, BRANCH_MERGE_PROPOSAL_FINAL_STATES))
 
     @property
     def dependent_branches(self):

=== modified file 'lib/lp/code/model/tests/test_branch.py'
--- lib/lp/code/model/tests/test_branch.py	2011-08-22 18:43:18 +0000
+++ lib/lp/code/model/tests/test_branch.py	2011-08-24 16:21:07 +0000
@@ -1780,6 +1780,18 @@
             set([(person1, 'review1'), (person2, 'review2')]), votes)
 
 
+class TestLandingCandidates(TestCaseWithFactory):
+
+    layer = DatabaseFunctionalLayer
+
+    def test_private_branch(self):
+        """landing_candidates works for private branches."""
+        branch = self.factory.makeBranch(private=True)
+        with person_logged_in(removeSecurityProxy(branch).owner):
+            mp = self.factory.makeBranchMergeProposal(target_branch=branch)
+            self.assertContentEqual([mp], branch.landing_candidates)
+
+
 class BranchDateLastModified(TestCaseWithFactory):
     """Exercies the situations where date_last_modifed is udpated."""
     layer = DatabaseFunctionalLayer

